c
c Home directory
c
      character homedir*(*)
      Parameter ( homedir = '/home/masunaga/SDSimulator/' )
c      
c Grid dimensions
c
      Include 'GRIDparameters.inc'
c
c  ######## microwave radiometer #######
c
c mxfreq : The number of channels
c
      Integer mxfreq
      Parameter ( mxfreq = 5 )
c
c - The following variables are defined in "param_set-BMCV.f"
c
c fov_ct_microw : cross-track FOV size at each channel
c fov_dt_microw : down-track FOV size at each channel
c
      real *4 fov_ct_microw( mxfreq )
      real *4 fov_dt_microw( mxfreq )
c
c  ############## radar ###############
c
c mxfreq_radar : The number of channels
c                          
      Integer mxfreq_radar
      Parameter ( mxfreq_radar  = 1 )
c
c - The following variables are defined in "param_set-BMCV.f"
c
c fov_ct_radar : cross-track FOV size at each channel
c fov_dt_radar : down-track FOV size at each channel
c
      real *4 fov_ct_radar ( mxfreq_radar )
      real *4 fov_dt_radar ( mxfreq_radar )
c
c  ######## visible/IR imager ##########
c
c mxwavel : The number of channels
c                          
      Integer mxwavel
      Parameter ( mxwavel = 5 )
c
c - The following variables are defined in "param_set-BMCV.f"
c
c fov_ct_visir : cross-track FOV size
c fov_dt_visir : down-track FOV size
c                (FOV size is common to all visible/IR channels)
c wavel        : channel wavelegths
c tbform       : defines the input data type (radiance or Tb) at each channel.
c
      real *4 fov_ct_visir
      real *4 fov_dt_visir
      real *4 wavel(mxwavel)
      Logical tbform(mxwavel)
c
c ###### input model definitions ######
c
c CRM file list
c
c nmodel : The number of input model
c
      integer   nmodel
      parameter ( nmodel = 4 )
c
c CRM_file_list : Input file names, defined in "def_file_list.f".
c
      character CRM_file_list(nmodel)*90
c
c ########## running options ##########
c
c - The following variables are defined in "param_set-BMCV.f"
c
c microw : microwave simulator switch; on (off) when .true. (.false.)
c radar  : radar simulator switch    ; on (off) when .true. (.false.)
c visIR  : visble/IR simulator switch; on (off) when .true. (.false.)
c crosst_x : defines the cross-track direction in the model coordinates.
c
      Logical crosst_x,microw,radar,visIR
c
c ########### output parameters #############
c
c Tb_microw : input/output microwave brightness temperature in [K]
c   (  The last dimension (0:1) defines horizontal and vertical 
c      polarizations in this order. )
c
      real *4 Tb_microw(mxgridx,mxgridy,mxfreq,0:1)
c
c dBZ_radar: input/output radar reflectivity in [dBZ]
c PIA_radar: input/output two-way path-integrated attenuation [dB]
c
      real *4 dBZ_radar(mxgridx,mxgridy,mxlyr,mxfreq_radar)
      real *4 PIA_radar(mxgridx,mxgridy,mxfreq_radar)
c
c input/output visible radiance in [W/m2/str/micron] and IR Tb in [K]
c
      real *4 I_visir(mxgridx,mxgridy,mxwavel)
c
c ############## I/O paths ################
c
c outputdir : Output directory 
c             The I/O path is common to input and output Tb/Z/PIA/radiance.
c
      character outputdir*(*)
      parameter ( outputdir = homedir//'outputs/' )
