      SUBROUTINE CPCON(C)
C MACHINE CONSTANTS OF COMPUTER
C--- OUTPUT
C C     R(3)      (1)  MINIMUM POSITIVE X FOR  1+X      .NE. 1
C                      AVERAGE AS A RESULT OF COMPLEX ARITHMETIC
C                      OPERATIONS.
C                 (2)  MINIMUM EXPONENT Y FOR  10.0**Y  .NE. 0
C                 (3)  MAXIMUM EXPONENT Z FOR  10.0**Z  IS MAX. VALUE
C                  IF INIT=1 (DATA STATEMENT) THEN  SET AS Z=Y
C                  IF INIT=2 THEN THIS ROUTINE GETS ACTUAL VALUE OF Z.
C                  - SEE NOTE -
C--- HISTORY
C 90. 1.20  CREATED
C     6.27  CHANGE THE ALGORITHM TO GET X AND Y TAKING INTO ACCOUNT THE
C           HIGH ACCURACY CO-PROCESSOR AND GRACEFUL UNDERFLOW.
C 92. 3.21  N=1000 from N=200
C     7. 9  BUG IN X-DEFINITION
C--- NOTE
C THIS PROGRAM WILL GENERATE -UNDERFLOW ERROR- AND -OVERFLOW ERROR-
C  MESSAGES.  ON SOME COMPUTER -OVERFLOW ERROR- MESSAGE MAY BE
C  FATAL ERROR.  IN THAT CASE, PLEASE SET INIT = 1 IN THE DATA
C  SATEMENT FOR SUPPRESSING THE PROCEDURE OF GETTING C(3).
      DIMENSION C(*)
      CHARACTER CH*80
C RESOLUTION OF COMPUTATION
      SAVE INIT,X,Y,Z
      DATA INIT/1/
      IF(INIT.LE.0) THEN
        C(1)=X
        C(2)=Y
        C(3)=Z
        RETURN
      ENDIF
CC TEST SUM(K=1,M) COS((2K-1)*PI/(2M+1)) = 0.5
CC SIMPLE CHECK, X = X + E, IS NOT VALIDE WHEN THE COMPUTER
CC  USE A HIGH ACCURATE CO-PROCESSOR.
      N=500
      PI=ASIN(1.0)*2
      M0=10
      X=0
      DO 1 M=1,M0
      Y=0
      DO 2 K=1,M
    2 Y=Y+COS((2*K-1)*PI/(2*M+1))
      Y=ABS(2*Y-1)
      X=X+Y
    1 CONTINUE
      X=X/M0
      C(1)=X
C EXPONENT FOR MINIMUM POSITIVE VALUE
C  THIS PROCEDURE WILL GENERATE -UNDERFLOW ERROR MESSAGE-
      Y2=1
      N=1000
      DO 3 I=1,N
      Y1=Y2
      Y3=Y1/10
CC FOR GRACEFUL UNDERFLOW
CC EVEN Y2 BECOMES 0 AS OUTPUT, Y2 IS NOT 0 INSIDE
CC COMPUTER WHEN GRACEFUL UNDERFLOW IS APPLIED.
CC SO WE REPLACE THE VALUE OF Y2 BY OUTPUT.
      CH='0'
      WRITE(CH,7) Y3
    7 FORMAT(1P,E12.5)
      Y2=0
      READ(CH,*) Y2
      IF(ABS(10*Y2/Y1-1) .GT. 5*X) GOTO 4
    3 CONTINUE
      I=N+1
    4 Y=1-I
      C(2)=Y
C EXPONENT FOR MAXIMUM POSITIVE VALUE
C THIS PROCEDURE WILL GENERATE -OVERFLOW MESSAGE-
      IF(INIT.LE.1) THEN
        Z=-Y
       ELSE
        Z2=1
        DO 5 I=1,N
        Z1=Z2
        Z2=Z1*10
        IF(ABS(Z2/Z1/10-1) .GT. 5*X) GOTO 6
    5   CONTINUE
        I=N+1
    6   Z=I-1
      ENDIF
      C(3)=Z
C
      INIT=0
      RETURN
      END
